import { Node, Color, Sprite, SpriteFrame, SpriteComponent, Collider2D, CircleCollider2D } from 'cc';

/**
 * Base class for Collectibles extends BaseNode.<br/>
 *
 * Comes with grip related functionalities and properties.
 */
export class Collectible extends Node {
  private image: Sprite;

  constructor(spriteFrame: SpriteFrame) {
    super('collectible');

    this.image = this.addComponent(SpriteComponent);
    this.image.spriteFrame = spriteFrame;

  }

  changeColor(color: string): void {
    this.image.color = new Color().fromHEX(color);
  }
}
