
import { _decorator, Component, Node, resources, SpriteFrame, Collider, instantiate, Vec2, Vec3, view, macro } from 'cc';
import { Collectible } from './Collectible';
import { Grip } from './Grip';
const { ccclass, property } = _decorator;

@ccclass('Main')
export class Main extends Component {
    // [1]
    // dummy = '';

    // [2]
    // @property
    // serializableDummy = 0;

    gripPrefab!: Node
    collectiblePrefab!: Node;

    onLoad() {
        const paths = [
            'gripSmall/spriteFrame',
            'white/spriteFrame'
        ]
        let loadCount = paths.length;
        resources.load(paths, SpriteFrame, (err, res) => {
            if (err) {
                console.error('Error loading!', err);
                return;
            }
            loadCount--;
            console.log('loaded', res);
            this.startGen();
        });
    }

    start () {

        // [3]
    }

    private startGen() {
        const gripRes = resources.get('gripSmall/spriteFrame', SpriteFrame)!;
        const collectibleRes = resources.get('white/spriteFrame', SpriteFrame)!;

        this.gripPrefab = new Grip(gripRes, gripRes, 'grip');
        this.collectiblePrefab = new Collectible(collectibleRes);
        console.log('prefab created');

        const { width, height } = view.getDesignResolutionSize();
        this.schedule(() => {
            console.log('grip created');
            const grip = instantiate(this.gripPrefab);
            grip.setPosition(new Vec3(-width * 0.5 + Math.random() * width, height * 0.5 + Math.random() * height));
            this.node.addChild(grip);

            const collectible = instantiate(this.collectiblePrefab);
            grip.addChild(collectible);
        }, 2, macro.REPEAT_FOREVER, 2);
    }

    // update (deltaTime: number) {
    //     // [4]
    // }
}

/**
 * [1] Class member could be defined like this.
 * [2] Use `property` decorator if your want the member to be serializable.
 * [3] Your initialization goes here.
 * [4] Your update function goes here.
 *
 * Learn more about scripting: https://docs.cocos.com/creator/3.0/manual/en/scripting/
 * Learn more about CCClass: https://docs.cocos.com/creator/3.0/manual/en/scripting/ccclass.html
 * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.0/manual/en/scripting/life-cycle-callbacks.html
 */
